/* GCC */
#include <iostream>
#include<algorithm>
#include<cstdio>
#include<vector>
using namespace std;
int Parent[100000];
vector<int> gr[100000];
long long g[100000];
long long f[100000];
long long pr[100000];
long long revpr[100000];
bool used[100000];
int Cycle[100000];
int Cyclec;
int p,n;
void findCycle(int v,int par)
{
    static bool b=false;
    used[v]=true;
    for(int i=0;i<gr[v].size();i++)
    {
        if(b)
            return;
        if(gr[v][i]==par)
            continue;
        if(!used[gr[v][i]])
        {
            Parent[gr[v][i]]=v;
            findCycle(gr[v][i],v);
        }
        else
        {
            int t=v;
            while(t!=gr[v][i])
            {
                Cycle[Cyclec++]=t;
                t=Parent[t];
            }
            Cycle[Cyclec++]=gr[v][i];
            b=true;
        }
    }
}
void dfs(int v,int par,int banned)
{
    used[v]=true;
    g[v]=1;
    f[v]=0;
    vector<int> id;
    if(par==-1 && gr[v].size()==1)
    {
        g[v]=1;
        f[v]=1;
        return;
    }
     if(gr[v].size()==0)
    {
        g[v]=1;
        f[v]=1;
        return;
    }
    for(int i=0;i<gr[v].size();i++)
    {
        if(!used[gr[v][i]] && gr[v][i]!=banned)
        {
            id.push_back(gr[v][i]);
            dfs(gr[v][i],v,-1);
            g[v]=(g[v]*f[gr[v][i]])%p;
        }
    }
    if(id.size()==0)
    {
        g[v]=1;
        f[v]=1;
        return;
    }
    if(id.size()==1)
    {
        f[v]=g[v]+g[id[0]];
        return;
    }
    pr[0]=f[id[0]]%p;
    for(int i=1;i<id.size();i++)
    {
        pr[i]=pr[i-1]*f[id[i]]%p;
    }
    revpr[id.size()-1]=f[id.back()]%p;
    for(int i=id.size()-2;i>=0;i--)
    {
       revpr[i]=revpr[i+1]*f[id[i]]%p;
    }
    for(int i=1;i<id.size()-1;i++)
        f[v]=(f[v]+pr[i-1]*revpr[i+1]*g[id[i]])%p;
    f[v]=(f[v]+revpr[1]*g[id[0]])%p;
    f[v]=(f[v]+pr[id.size()-2]*g[id.back()])%p;
    f[v]=(f[v]+g[v])%p;
}
int main()
{
    freopen("museum.in","r",stdin);
    freopen("museum.out","w",stdout);
    cin>>n>>p;
    for(int i=0;i<n;i++)
    {
        int a,b;
        scanf("%d%d",&a,&b);
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    findCycle(1,-1);
    for(int i=0;i<=n;i++)
        used[i]=false;
    for(int i=0;i<Cyclec;i++)
        used[Cycle[i]]=true;
    long long ans=0;
    int anst=2;
    for(int i=1;i<=n;i++)
    {
        if(!used[i])
        {
            dfs(i,-1,-1);
            anst=anst*f[i]%p;
        }
    }
    ans=(ans+anst)%p;



     for(int i=0;i<=n;i++)
        used[i]=false;
    anst=1;
    used[Cycle[0]]=true;
    used[Cycle[1]]=true;
    for(int i=1;i<=n;i++)
    {
        if(!used[i])
        {
            dfs(i,-1,-1);
            anst=anst*f[i]%p;
        }
    }
    ans=(ans+anst)%p;
    for(int i=0;i<=n;i++)
        used[i]=false;
    dfs(Cycle[0],-1,Cycle[1]);
    ans=(ans+f[Cycle[0]])%p;
    cout<<ans<<endl;
    return 0;
}
